
/* ---------------------------------------------------------------------------
   A. Veneziani -  Programma che calcola la somma di tre frazioni
                   ricavando la frazione risultante
                   - Effettua il calcolo dell' m.c.m. -
   --------------------------------------------------------------------------- */                

#include <iostream.h>
#include <math.h>
#include <conio.h>

// struttura che definisce una frazione
struct fraz {
   int num;
   int den;  };

// routine per ridurre una frazione ai minimi termini
fraz riduci_fraz(fraz fr)
{
    int scan_fatt, mn;
    bool num_div, den_div;

    // individua il valore minimo tra numeratore e denominatore
    mn = min(fr.num,fr.den);

    // scandisce testando tutti i valori da 2 al valore minimo
    // tra numeratore e denominatore in cerca di fattori 
    scan_fatt = 2;
    while (scan_fatt <= mn)
    {
         // controlla se scan_fatt e' fattore del numeratore e denominatore
         num_div = ((fr.num % scan_fatt) == 0);
         den_div = ((fr.den % scan_fatt) == 0);

         // se e' fattore comune effettua riduzione
         if (num_div && den_div)
         {
             fr.num = fr.num / scan_fatt;
             fr.den = fr.den / scan_fatt;
         }
         else
            scan_fatt++;
     }

     return(fr);
}   

// individua i fattori di n rendendo
// l'esponente del fattore ed n diviso per
// il fattore considerato stesso 
int fattore(int& n, int fatt)
{
    bool fine;
    int esp;

    esp = 0;
    fine = false;
    while (! fine)
    {
        if ((n % fatt) == 0)
        {
           esp++;
           n = n / fatt;
        }   
        else
           fine = true;
    }

    return(esp);
}

// calcola il minimo comune multiplo tra due numeri n1 e n2
int mcm(int n1, int n2)
{
     int scan_fatt, nmx, ris;
     int exp1, exp2, exp_mx, base;

     // individua il numero piu' alto fra i due
     nmx = max(n1,n2);
  
     // scandisce alla ricerca di fattori
     ris = 1;
     for (scan_fatt = 2; scan_fatt <= nmx; scan_fatt++)
     {
         // individua se scan_fatt e' un fattore
         // e la sua molteplicita'
         exp1 = fattore(n1,scan_fatt);
         exp2 = fattore(n2,scan_fatt);

         // individua con il massimo esponente il fattore
         // comune o non comune ai due numeri
         if ((exp1 != 0) || (exp2 != 0))
         {
             // individua il "massimo esponente"
             exp_mx = max(exp1,exp2);

             // effettua il calcolo del risultato
             // moltiplicando per il fattore  individuato sopra
             ris = ris * pow(scan_fatt,exp_mx);
         }
     }
         
     return(ris);
}

// stampa di una frazione
void stampa_fraz(fraz fr)
{
    cout << fr.num << " / " << fr.den;
}


void main()
{
    fraz fr1, fr2, fr3, fris;
    int min_com_mult;

    cout << "Fornisci 3 frazioni da sommare (num  den):" << endl;
    // lettura delle frazioni
    cin >> fr1.num >> fr1.den;
    cin >> fr2.num >> fr2.den;
    cin >> fr3.num >> fr3.den;

    // riduzione delle frazioni in ingresso
    fr1 = riduci_fraz(fr1);
    fr2 = riduci_fraz(fr2);
    fr3 = riduci_fraz(fr3);

    // calcolo dell' m.c.m. dei denominatori e sua stampa
    min_com_mult = mcm(mcm(fr1.den,fr2.den),fr3.den);
    cout << "L' m.c.m. delle frazioni e': " << min_com_mult << endl;

    // calcolo della frazione risultante dalla somma delle tre originarie
    fris.den = min_com_mult;
    fris.num = min_com_mult / fr1.den * fr1.num +
               min_com_mult / fr2.den * fr2.num +
               min_com_mult / fr3.den * fr3.num;

    // stampa della frazione risultante 
    cout << "La frazione risultante e':  ";
    stampa_fraz(fris);
    
    getch();  

}
